'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactstrap = require('reactstrap');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PaginationComponent = function (_Component) {
    _inherits(PaginationComponent, _Component);

    function PaginationComponent(props) {
        _classCallCheck(this, PaginationComponent);

        var _this = _possibleConstructorReturn(this, (PaginationComponent.__proto__ || Object.getPrototypeOf(PaginationComponent)).call(this, props));

        _initialiseProps.call(_this);

        _this.state = {
            activePage: _this.props.activePage,
            firstPaginationNumber: 1
        };
        _this.pages = _this.getNumberOfPages(_this.props);
        return _this;
    }

    _createClass(PaginationComponent, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(props) {
            this.pages = this.getNumberOfPages(props);
            this.forceUpdate();
        }
    }, {
        key: 'render',
        value: function render() {
            return _react2.default.createElement(
                _reactstrap.Pagination,
                null,
                this.paginationItems()
            );
        }
    }]);

    return PaginationComponent;
}(_react.Component);

var _initialiseProps = function _initialiseProps() {
    var _this2 = this;

    this.getNumberOfPages = function (props) {
        var auxPages = props.totalItems / props.pageSize;
        var pages = parseInt(auxPages, 10);
        pages += pages !== auxPages ? 1 : 0;
        return pages;
    };

    this.paginationItems = function () {
        var items = [];
        _this2.lastPaginationNumber = _this2.getLastPaginationNumber();
        items.push(_this2.firstOrLastPagItem("First", 1));
        items.push(_this2.nextOrPreviousPagItem("Previous", 1, 'l'));
        for (var i = _this2.state.firstPaginationNumber; i <= _this2.lastPaginationNumber; i++) {
            items.push(_this2.numberedPagItem(i));
        }
        items.push(_this2.nextOrPreviousPagItem("Next", _this2.pages, 'r'));
        items.push(_this2.firstOrLastPagItem("Last", _this2.pages));
        return items;
    };

    this.getLastPaginationNumber = function () {
        var minNumberPages = Math.min(_this2.pages, _this2.props.maxPaginationNumbers);
        return _this2.state.firstPaginationNumber + minNumberPages - 1;
    };

    this.numberedPagItem = function (i) {
        return _react2.default.createElement(
            _reactstrap.PaginationItem,
            { key: i, id: 'pagebutton' + i, active: _this2.state.activePage === i, onClick: _this2.handleClick },
            _react2.default.createElement(
                _reactstrap.PaginationLink,
                { style: { minWidth: '43.5px' } },
                i
            )
        );
    };

    this.nextOrPreviousPagItem = function (name, page, direction) {
        return _react2.default.createElement(
            _reactstrap.PaginationItem,
            { key: name, disabled: _this2.state.activePage === page, onClick: function onClick(e) {
                    return _this2.handleSelectNextOrPrevious(direction);
                } },
            _react2.default.createElement(
                _reactstrap.PaginationLink,
                null,
                name
            )
        );
    };

    this.firstOrLastPagItem = function (name, page) {
        var event = {
            currentTarget: {
                getAttribute: function getAttribute() {
                    return 'pagebutton' + page;
                }
            }
        };
        return _react2.default.createElement(
            _reactstrap.PaginationItem,
            { key: name, disabled: _this2.state.activePage === page, onClick: function onClick() {
                    return _this2.handleClick(event);
                } },
            _react2.default.createElement(
                _reactstrap.PaginationLink,
                null,
                name
            )
        );
    };

    this.handleClick = function (event) {
        var newActivePage = parseInt(event.currentTarget.getAttribute("id").split("pagebutton").pop(), 10);
        _this2.setState({
            activePage: newActivePage
        });
        _this2.handlePaginationNumber(newActivePage);
        _this2.props.onSelect(newActivePage);
    };

    this.handleSelectNextOrPrevious = function (direction) {
        var activePage = _this2.state.activePage;
        if (direction === 'r' && activePage === _this2.pages || direction === 'l' && activePage === 1) return;

        var newActivePage = direction === 'r' ? activePage + 1 : activePage - 1;

        _this2.setState({
            activePage: newActivePage
        });

        _this2.handlePaginationNumber(newActivePage);
        _this2.props.onSelect(newActivePage);
    };

    this.handlePaginationNumber = function (activePage) {
        var distance = Math.floor(_this2.props.maxPaginationNumbers / 2);
        var newFPNumber = activePage - distance;
        var newLPNumber = activePage + distance;
        if (newFPNumber <= distance) {
            if (_this2.state.firstPaginationNumber !== 1) {
                _this2.setState({
                    firstPaginationNumber: 1
                });
            }
        } else if (newLPNumber <= _this2.pages) {
            _this2.setState({
                firstPaginationNumber: newFPNumber
            });
        } else if (newLPNumber >= _this2.pages) {
            _this2.setState({
                firstPaginationNumber: _this2.pages - _this2.props.maxPaginationNumbers + 1
            });
        }
    };
};

PaginationComponent.propTypes = {
    totalItems: _propTypes2.default.number.isRequired,
    pageSize: _propTypes2.default.number.isRequired,
    onSelect: _propTypes2.default.func.isRequired,
    maxPaginationNumbers: _propTypes2.default.number,
    activePage: _propTypes2.default.number
};

PaginationComponent.defaultProps = {
    maxPaginationNumbers: 5,
    activePage: 1
};

exports.default = PaginationComponent;